# 2023-08-22 Triage Log

A week with very few real regressions and some good improvements through work done by @cjgillot who found a few spots where the compiler was doing unnecessary work.

Triage done by **@rylev**.
Revision range: [e845910..d4a881](https://perf.rust-lang.org/?start=e8459109bbb440764c1c877032189a27b9e76c4e&end=d4a881e1433cd10e424843353e1f939f5a798f4e&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.4%  | [0.5%, 2.6%]   | 13    |
| Regressions ❌ <br /> (secondary)  | 0.6%  | [0.3%, 0.8%]   | 8     |
| Improvements ✅ <br /> (primary)   | -0.7% | [-1.4%, -0.3%] | 59    |
| Improvements ✅ <br /> (secondary) | -0.8% | [-1.3%, -0.3%] | 38    |
| All ❌✅ (primary)                 | -0.3% | [-1.4%, 2.6%]  | 72    |


3 Regressions, 2 Improvements, 2 Mixed; 2 of them in rollups
28 artifact comparisons made in total

#### Regressions

Warn on inductive cycle in coherence leading to impls being considered not overlapping [#114023](https://github.com/rust-lang/rust/pull/114023) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=d7e751006cb3691d1384b74196a9cb45447acfa8&end=a32978a5e8a3c34bb5caa1175f7404c2ede019b6&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.3% | [0.6%, 2.5%] | 10    |
| Regressions ❌ <br /> (secondary)  | -    | -            | 0     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 1.3% | [0.6%, 2.5%] | 10    |
- The author is investigating whether this is due to the use of a temporary lint or if there is some more fundamental change happening here.


Rollup of 7 pull requests [#114879](https://github.com/rust-lang/rust/pull/114879) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4e3ce0e782a30d467ddbc542c3eb5d215eac1b9d&end=60713f4234c56e21f77e37c61dd731247d0b9429&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3% | [0.3%, 0.3%] | 2     |
| Regressions ❌ <br /> (secondary)  | 0.5% | [0.4%, 0.6%] | 8     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.3% | [0.3%, 0.3%] | 2     |
- The perf result seems to just be noise.


Remove conditional use of `Sharded` from query caches [#114892](https://github.com/rust-lang/rust/pull/114892) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=f3b4c6746aa0e278797ae52e2c16fdef04136e3a&end=c5833f1956bea474034ffec5ab2c75f343548038&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4% | [0.2%, 0.5%] | 3     |
| Regressions ❌ <br /> (secondary)  | 0.5% | [0.4%, 0.6%] | 8     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.4% | [0.2%, 0.5%] | 3     |
- Perf results are small and worth the simplification in code.


#### Improvements

Do not mark shallow_lint_levels_on as eval_always. [#114536](https://github.com/rust-lang/rust/pull/114536) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=656ee47db32e882fb02913f6204e09cc7a41a50e&end=4e3ce0e782a30d467ddbc542c3eb5d215eac1b9d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.4%  | [0.4%, 0.4%]   | 1     |
| Improvements ✅ <br /> (primary)   | -0.7% | [-1.3%, -0.3%] | 30    |
| Improvements ✅ <br /> (secondary) | -0.5% | [-1.0%, -0.3%] | 15    |
| All ❌✅ (primary)                 | -0.7% | [-1.3%, -0.3%] | 30    |


Only run MaybeInitializedPlaces dataflow once to elaborate drops [#111555](https://github.com/rust-lang/rust/pull/111555) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=07438b0928c6691d6ee734a5a77823ec143be94d&end=f3b4c6746aa0e278797ae52e2c16fdef04136e3a&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.6%  | [0.6%, 0.6%]   | 1     |
| Improvements ✅ <br /> (primary)   | -0.8% | [-1.3%, -0.3%] | 27    |
| Improvements ✅ <br /> (secondary) | -0.7% | [-1.1%, -0.4%] | 32    |
| All ❌✅ (primary)                 | -0.8% | [-1.3%, -0.3%] | 27    |


#### Mixed

add a csky-unknown-linux-gnuabiv2 target [#113658](https://github.com/rust-lang/rust/pull/113658) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=f960bdf1feacad4ab5a079c76ff31053c1799f71&end=180dffba142c47240ca0d93096ce90b9fd97c8d7&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 1.3%  | [0.3%, 1.9%]   | 3     |
| Regressions ❌ <br /> (secondary)  | 0.3%  | [0.3%, 0.3%]   | 1     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.3%, -0.2%] | 4     |
| Improvements ✅ <br /> (secondary) | -0.3% | [-0.4%, -0.2%] | 4     |
| All ❌✅ (primary)                 | 0.4%  | [-0.3%, 1.9%]  | 7     |
- Noise


Rollup of 10 pull requests [#114852](https://github.com/rust-lang/rust/pull/114852) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4f4dae055b470c889968b02964a28477f9daff62&end=c57393e4f8b88444fbf0985a81a2d662862f2733&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.5%  | [0.5%, 0.6%]   | 4     |
| Regressions ❌ <br /> (secondary)  | 1.0%  | [1.0%, 1.0%]   | 3     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -0.3% | [-0.3%, -0.3%] | 1     |
| All ❌✅ (primary)                 | 0.5%  | [0.5%, 0.6%]   | 4     |
- Noise

